%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           python-tripleoclient
Version:        9.2.7
Release:        11%{?dist}
Summary:        OpenstackClient plugin for tripleoclient

License:        ASL 2.0
URL:            https://pypi.python.org/pypi/python-tripleoclient
Source0:        https://tarballs.openstack.org/python-tripleoclient/python-tripleoclient-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=9.2.7
Patch0001: 0001-DOWNSTREAM-ONLY-Always-include-docker-environment-fi.patch
Patch0002: 0002-Allow-passing-an-agent-name-as-a-command-line-argume.patch
Patch0003: 0003-Introduce-trivial-helpers-to-manage-image_files-and-.patch
Patch0004: 0004-Always-define-properties-for-image-even-if-empty.patch
Patch0005: 0005-Add-architecture-support-when-uploading-images.patch
Patch0006: 0006-Add-platform-support-when-uploading-images.patch
Patch0007: 0007-Actually-use-the-arch-and-platform-to-select-appropr.patch
Patch0008: 0008-Switch-to-using-assert_has_calls-instead-of-assertEq.patch
Patch0009: 0009-Always-set-a-hardware-architecture-on-uploaded-image.patch
Patch0010: 0010-Fixup-hard-coded-hw_architecture-in-unittest.patch
Patch0011: 0011-Don-t-validate-stack-when-creating-updating-plan.patch
Patch0012: 0012-Handle-workflow-error-for-enable_ssh_admin.patch
Patch0013: 0013-Revert-Fix-setup.cfg.patch
Patch0014: 0014-overcloud-plan-deployment-status.patch
Patch0015: 0015-Use-sync-action-get_deployment_failures.patch
Patch0016: 0016-openstack-overcloud-failures.patch
Patch0017: 0017-Get-the-failed-status-for-update-prepare.patch
Patch0018: 0018-Use-a-single-queue-for-update-upgrade.patch
Patch0019: 0019-Check-that-the-networks-are-defined-on-update.patch
Patch0020: 0020-Queen-Only-Add-force-option-to-undercloud-update.patch
Patch0021: 0021-Add-ODL-deprecation-warning-in-CLI.patch
Patch0022: 0022-Don-t-exit-on-a-RUNNING-message-for-deploy-workflow.patch
Patch0023: 0023-Change-OSP-versions-to-be-of-downstream.patch
Patch0024: 0024-DOWNSTREAM-ONLY-Handle-tls-endpoint-for-zaqar-websoc.patch
Patch0025: 0025-Add-verbosity-level-to-the-ansible-update-upgrade-ru.patch
Patch0026: 0026-Use-OS_CACERT-for-zaqar-s-websocket-connection.patch
Patch0027: 0027-Ensure-files-exist-before-building-uploading-plan.patch
Patch0028: 0028-Retry-heat-stack-polling-on-gateway-problems.patch

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python2-pbr
BuildRequires:  python2-setuptools
# testing requirements
BuildRequires:  python2-fixtures
BuildRequires:  python2-mock
BuildRequires:  python2-testrepository
BuildRequires:  python2-testtools
BuildRequires:  python2-cliff
BuildRequires:  python2-ironicclient
BuildRequires:  python-ironic-inspector-client
BuildRequires:  python2-heatclient
BuildRequires:  python2-mistralclient
BuildRequires:  python2-openstackclient
BuildRequires:  python2-oslo-config
BuildRequires:  python-websocket-client
BuildRequires:  python2-zaqarclient
BuildRequires:  python2-testscenarios
BuildRequires:  PyYAML
BuildRequires:  python2-passlib
BuildRequires:  openstack-tripleo-common
BuildRequires:  python2-osc-lib-tests
BuildRequires:  python-requests-mock
BuildRequires:  git
BuildRequires:  instack-undercloud
BuildRequires:  openstack-macros

Requires:       instack
Requires:       instack-undercloud
Requires:       openstack-selinux
Requires:       python2-babel >= 2.3.4
Requires:       python2-cliff
Requires:       python-ipaddress
Requires:       python-ironic-inspector-client >= 1.5.0
Requires:       python2-ironicclient >= 2.2.0
Requires:       python2-heatclient >= 1.10.0
Requires:       python2-mistralclient >= 3.1.0
Requires:       python2-openstackclient >= 3.12.0
Requires:       python2-osc-lib >= 1.8.0
Requires:       python2-pbr
Requires:       python2-psutil
Requires:       python-websocket-client
Requires:       python2-passlib
Requires:       python-simplejson >= 3.5.1
Requires:       python2-six
Requires:       sos
Requires:       openstack-tripleo-common >= 7.1.0
Requires:       python2-zaqarclient >= 1.0.0
Requires:       python2-cryptography >= 1.7.2
# Required for config-download/FFU LP#1816447
Requires:       openstack-tripleo-validations

Obsoletes: python-rdomanager-oscplugin < 0.0.11
Provides: python-rdomanager-oscplugin = %{version}-%{release}

%description
python-tripleoclient is a Python plugin to OpenstackClient
for TripleO <https://github.com/openstack/python-tripleoclient>.

# Not supported by OSP yet
%package heat-installer
Summary:        Components required for a containerized undercloud

# Required for containerized undercloud
Requires:       docker
Requires:       docker-distribution
Requires:       python-ipaddr
Requires:       openvswitch
Requires:       openstack-heat-agents
Requires:       openstack-heat-api
Requires:       openstack-heat-engine
# required as we now use --heat-native
Requires:       openstack-heat-monolith
Requires:       openstack-tripleo-heat-templates
Requires:       puppet-tripleo

%description heat-installer
python-tripleoclient-heat-installer is a sub-package that contains all dependencies to
deploy a containerized undercloud with tripleo client.

%prep
%autosetup -n %{name}-%{upstream_version} -S git
sed -i '/setup_requires/d; /install_requires/d; /dependency_links/d' setup.py

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
%{__python2} setup.py build
PYTHONPATH=. oslo-config-generator --config-file=config-generator/undercloud.conf

%install
%{__python2} setup.py install --skip-build --root %{buildroot}
install -p -D -m 640 undercloud.conf.sample  %{buildroot}/%{_datadir}/%{name}/undercloud.conf.sample

%check
PYTHONPATH=. %{__python2} setup.py testr -t "--concurrency=1"

%files
%{_datadir}/%{name}
%{python2_sitelib}/tripleoclient*
%{python2_sitelib}/python_tripleoclient*
%doc LICENSE README.rst

%files heat-installer

%changelog
* Thu Jul 11 2019 Alex Schultz <aschultz@redhat.com> 9.2.7-11
- Retry heat stack polling on gateway problems (rhbz#1727947)

* Fri Jul 05 2019 Cédric Jeanneret <cjeanner@redhat.com> 9.2.7-10
- Ensure files exist before building/uploading plan (rhbz#1726322)

* Wed Jun 12 2019 Bohdan Dobrelia <bdobreli@redhat.com> 9.2.7-9
- Use OS_CACERT for zaqar's websocket connection (rhbz#1714205)

* Wed Jun 05 2019 Steve Linabery <slinaber@redhat.com> 9.2.7-8
- Add verbosity level to the ansible update/upgrade run

* Mon Jun 03 2019 Bohdan Dobrelia <bdobreli@redhat.com> 9.2.7-7
- [DOWNSTREAM-ONLY] Handle tls endpoint for zaqar websocket client (rhbz#1714205)

* Wed May 29 2019 Janki Chhatbar <jchhatba@redhat.com> 9.2.7-6
- Change OSP versions to be of downstream (rhbz#1705350)

* Tue May 28 2019 Luke Short <lshort@redhat.com> 9.2.7-5
- Don't exit on a RUNNING message for deploy workflow (rhbz#1692932)

* Tue May 28 2019 Janki Chhatbar <jchhatba@redhat.com> 9.2.7-4
- Add ODL deprecation warning in CLI (rhbz#1705350)

* Mon Apr 08 2019 Sofer Athlan-Guyot <sathlang@redhat.com> 9.2.7-3
- [Queen Only] Add force option to undercloud update. (rhbz#1654079)

* Fri Apr 05 2019 Jon Schlueter <jschluet@redhat.com> 9.2.7-2
- updtae to stable/queens (rhbz#1696847)
- Check that the networks are defined on update
- Use a single queue for update/upgrade
- Get the failed status for update prepare
- Update to 9.2.7 (rhbz#1696847)

* Tue Mar 26 2019 Luke Short <lshort@redhat.com> 9.2.6-11
- Revert "Fix setup.cfg" (rhbz#1692932)

* Tue Mar 26 2019 Luke Short <ekultails@gmail.com> 9.2.6-10
- openstack overcloud failures (rhbz#1688461)
- Use sync action get_deployment_failures (rhbz#1688461)
- overcloud plan deployment status (rhbz#1688461)
- Handle workflow error for enable_ssh_admin (rhbz#1688461)

* Tue Mar 12 2019 Rabi Mishra <ramishra@redhat.com> 9.2.6-9
- Don't validate stack when creating/updating plan (rhbz#1677230)

* Thu Feb 19 2019 Alex Schultz <aschultz@redhat.com> 9.2.6-8
- Add tripleo validations dependency (rhbz#1677166)

* Thu Feb 07 2019 Steve Linabery <slinaber@redhat.com> 9.2.6-7
- Disable SSH password authentication during tripleo-admin enablement.
- Catch websocket connection close errors in cleanup

* Fri Jan 18 2019 Alex Schultz <aschultz@redhat.com> 9.2.6-6
- Use existing stack parameter for DeployIdentifier (rhbz#1657571)

* Mon Dec 10 2018 Emilien Macchi <emilien@redhat.com> 9.2.6-5
- Bump the timeout for plan creation workflow to 20 minutes (rhbz#1619704)

* Mon Nov 26 2018 Jon Schlueter <jschluet@redhat.com> 9.2.6-4
- Ensure that the --template-file option is passed to the kolla builder
- Add a guard to break if no connection
- update (rhbz#1653341)

* Wed Nov 07 2018 Cédric Jeanneret <cjeanner@redhat.com> 9.2.6-3
- Increase the deploy_plan timeout in tripleoclient (rhbz#1644754)

* Wed Oct 17 2018 Jon Schlueter <jschluet@redhat.com> 9.2.6-2
- Update to 9.2.6 (rhbz#1640117)
- Issue a message to update nodes after updating images (rhbz#1572379)

* Tue Oct 16 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.3-6
- Insert break lines when showing FFWD upgrade operator warning. (rhbz#1566294)

* Fri Sep 07 2018 Michele Baldessari <michele@acksyn.org> 9.2.3-5
- Passwords mismatches when using custom plan env (rhbz#1624462)

* Fri Aug 03 2018 Jon Schlueter <jschluet@redhat.com> 9.2.3-4
- Fixup hard-coded hw_architecture in unittest (rhbz#1610657)
- Always set a hardware architecture on uploaded images (rhbz#1610657)
- Switch to using assert_has_calls() instead of assertEqual() (rhbz#1610657)
- Actually use the arch and platform to select appropriate images (rhbz#1610657)
- Add --platform support when uploading images (rhbz#1610657)
- Add --architecture support when uploading images (rhbz#1610657)
- Always define properties for image even if empty (rhbz#1610657)
- Introduce trivial helpers to manage image_files and names (rhbz#1610657)
- Allow passing an agent-name as a command line argument (rhbz#1610657)

* Wed Jul 18 2018 Jon Schlueter <jschluet@redhat.com> 9.2.3-2
- DeployIdentifier should be provided for any parameter actions (rhbz#1561131)
- Default environment/services/* to docker (rhbz#1600676)

* Sun Jul 15 2018 Jon Schlueter <jschluet@redhat.com> 9.2.3-1
- Update to 9.2.3

* Tue Jul 03 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.1-13
- Remove deploy playbook from `update run` (rhbz#1589346)

* Tue May 29 2018 Alex Schultz <aschultz@redhat.com> 9.2.1-12
- Composable role and service fails workflow (rhbz#1577536)

* Thu May 24 2018 Sergii Golovatiuk <sgolovat@redhat.com> 9.2.1-11
- Refactor, fix ansible inventory method parameters for ffwd-upgrade run (rhbz#1576079)

* Fri May 18 2018 mandreou <marios@redhat.com> 9.2.1-10
- Add .deployment.v1.deploy_on_servers to ffwd-upgrade prepare (rhbz#1561255)
- Update Heat stack on update/upgrade/ffwd converge (rhbz#1573922 rhbz#1576480 rhbz#1576482)
- Add ssh-user to get_tripleo_ansible_inventory (rhbz#1576079)

* Thu May 10 2018 Sergii Golovatiuk <sgolovat@redhat.com> 9.2.1-9
- Update Heat stack on update/upgrade/ffwd converge (rhbz#1573922 rhbz#1576480 rhbz#1576482)

* Wed May 09 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.1-8
- Add ssh-user to get_tripleo_ansible_inventory (rhbz#1576079)

* Wed May 09 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.1-7
- Regenerate overcloudrc on upgrade and ffwd-upgrade (prepare) (rhbz#1573026)

* Wed May 09 2018 Jon Schlueter <jschluet@redhat.com> 9.2.1-6
- Stop trying to converge during Ceph upgrade command (rhbz#1571901)

* Mon May 07 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.1-5
- Add --stack to update, upgrade and ffwd-upgrade 'run' CLI. (rhbz#1571805)

* Sat May 05 2018 Carlos Camacho <ccamacho@redhat.com> 9.2.1-4
- Add warning + required confirm for ffwd-upgrade cli --yes to skip (rhbz#1563373)
- Q upgrade - fixup completion messages and --help doctext (rhbz#1568714)
- Use only update/upgrade ansible queue instead (rhbz#1568714)

* Wed Apr 25 2018 Jason Joyce <jjoyce@redhat.com> 9.2.1-3
- [DOWNSTREAM-ONLY]Always include docker environment files in prepare command (rhbz#1500528 rhbz#1500529 rhbz#1500531 rhbz#1535971 rhbz#1535614)
- setup.cfg whitespace changes

* Wed Apr 25 2018 Jon Schlueter <jschluet@redhat.com> 9.2.1-2
- Introduce Ceph upgrade command (rhbz#1562209 rhbz#1569012 rhbz#1568986)

* Tue Apr 24 2018 Jon Schlueter <jschluet@redhat.com> 9.2.1-1
- Update to 9.2.1

* Fri Apr 20 2018 Jon Schlueter <jschluet@redhat.com> 9.2.0-5
- Update prepare using an environment file (rhbz#1568362)
- Add upgrade-[prepare|converge].yaml into upgrade cli (rhbz#1568367)

* Tue Apr 17 2018 Jon Schlueter <jschluet@redhat.com> 9.2.0-4
- Stop persisting previous configuration on update/upgrade prepare (rhbz#1541024)

* Thu Apr 12 2018 Jon Schlueter <jschluet@redhat.com> 9.2.0-3
- Allow providing --ssh-user for update/upgrade run commands
- Generate inventory with tripleo-admin user

* Wed Mar 28 2018 Jon Schlueter <jschluet@redhat.com> 9.2.0-2
- Pass plan/stack name into config_download workflow

* Tue Mar 27 2018 Jon Schlueter <jschluet@redhat.com> 9.2.0-1
- Update to 9.2.0

* Thu Mar 08 2018 RDO <dev@lists.rdoproject.org> 9.1.0-1
- Update to 9.1.0
